//+------------------------------------------------------------------+
//|                                     Multi BB Over Alert ver2.mq4 |
//|                                                 Cutzpr@Forex-TSD |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
extern string Details="Enter TF in Minutes";
extern string Details1="Enter Period for each TF, 20 is default";
//

extern int FontSize=8;
extern string FontType="Tahoma";
extern int BB_TF1=5;
extern int PERIOD1=20;
extern color TF1Color=CornflowerBlue;
extern bool TF1_Alert;
//
extern int BB_TF2=5;
extern int PERIOD2=60;
extern color TF2Color=SteelBlue;
extern bool TF2_Alert;
//
extern int BB_TF3=5;
extern int PERIOD3=240;
extern color TF3Color=MidnightBlue;
extern bool TF3_Alert;
//
extern bool MultiTF_Alert=false;
extern int xAdjust=20;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
  
     
  
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
 int deinit()
  {

   int total=ObjectsTotal();
   string name;
   for(;total>0;total--)
    {
     name=ObjectName(total);
    int index=StringFind(name,"BB",0);
      if(index!=-1) ObjectDelete(name);    
    }
    
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted(), limit;
 
   if(counted_bars>0) counted_bars--;
   
   limit=Bars-counted_bars;

   if(New_Bar()) // if functuion New_bar true
   {

   for(int i=0;i<limit;i++)
   {
      double
      BB1H=iBands(NULL,BB_TF1,PERIOD1,2,0,PRICE_HIGH,MODE_UPPER,i),  // BB for the 3 time frames
      BB1L=iBands(NULL,BB_TF1,PERIOD1,2,0,PRICE_LOW,MODE_LOWER,i),
      BB2H=iBands(NULL,BB_TF2,PERIOD2,2,0,PRICE_HIGH,MODE_UPPER,i),
      BB2L=iBands(NULL,BB_TF2,PERIOD2,2,0,PRICE_LOW,MODE_LOWER,i),
      BB3H=iBands(NULL,BB_TF3,PERIOD3,2,0,PRICE_HIGH,MODE_UPPER,i),
      BB3L=iBands(NULL,BB_TF3,PERIOD3,2,0,PRICE_LOW,MODE_LOWER,i);
   
      int adjust;
     switch(Period())
     {
       case 1:     adjust=1*xAdjust*60; break;  // Adjust the last coordinate for the TF
       case 5:     adjust=5*xAdjust*60; break;  
       case 15:    adjust=15*xAdjust*60; break;
       case 30:    adjust=30*xAdjust*60; break;
       case 60:    adjust=60*xAdjust*60; break;
       case 240:   adjust=240*xAdjust*60; break;
       case 1440:  adjust=1440*xAdjust*60; break;
       case 10080: adjust=10080*xAdjust*60; break;
       case 43200: adjust=43200*xAdjust*60; break;
     }
     
     
   datetime diff=Time[8]-Time[0];
   double spread=MarketInfo(Symbol(),MODE_SPREAD);
   
     
     // Create all object lines 
   ObjectCreate("BB1H",OBJ_TREND,0,TimeCurrent()-diff,BB1H,TimeCurrent()-diff+adjust,BB1H);
   ObjectCreate("BB1L",OBJ_TREND,0,TimeCurrent()-diff,BB1L,TimeCurrent()-diff+adjust,BB1L);
   ObjectCreate("BB2H",OBJ_TREND,0,TimeCurrent()-diff,BB2H,TimeCurrent()-diff+adjust,BB2H);
   ObjectCreate("BB2L",OBJ_TREND,0,TimeCurrent()-diff,BB2L,TimeCurrent()-diff+adjust,BB2L);
   ObjectCreate("BB3H",OBJ_TREND,0,TimeCurrent()-diff,BB3H,TimeCurrent()-diff+adjust,BB3H);
   ObjectCreate("BB3L",OBJ_TREND,0,TimeCurrent()-diff,BB3L,TimeCurrent()-diff+adjust,BB3L);
   
   //Style all object lines
   ObjectSet("BB1H",OBJPROP_COLOR,TF1Color);
   ObjectSet("BB1L",OBJPROP_COLOR,TF1Color);
   ObjectSet("BB2H",OBJPROP_COLOR,TF2Color);
   ObjectSet("BB2L",OBJPROP_COLOR,TF2Color);
   ObjectSet("BB3H",OBJPROP_COLOR,TF3Color);
   ObjectSet("BB3L",OBJPROP_COLOR,TF3Color);

   
   ObjectSet("BB1H",OBJPROP_WIDTH,2);
   ObjectSet("BB1L",OBJPROP_WIDTH,2);
   ObjectSet("BB2H",OBJPROP_WIDTH,2);
   ObjectSet("BB2L",OBJPROP_WIDTH,2);
   ObjectSet("BB3H",OBJPROP_WIDTH,3);
   ObjectSet("BB3L",OBJPROP_WIDTH,3);
 
  // Different set of Objects for Trend Line Labels
  ObjectCreate("M5 UPPER BB",OBJ_TEXT,0,ObjectGet("BB1H",OBJPROP_TIME1)+adjust,ObjectGet("BB1H",OBJPROP_PRICE2));
  ObjectCreate("M5 LOWER BB",OBJ_TEXT,0,ObjectGet("BB1L",OBJPROP_TIME1)+adjust,ObjectGet("BB1L",OBJPROP_PRICE2));
  ObjectCreate("M15 UPPER BB",OBJ_TEXT,0,ObjectGet("BB2H",OBJPROP_TIME1)+adjust,ObjectGet("BB2H",OBJPROP_PRICE2));
  ObjectCreate("M15 LOWER BB",OBJ_TEXT,0,ObjectGet("BB2L",OBJPROP_TIME1)+adjust,ObjectGet("BB2L",OBJPROP_PRICE2));
  ObjectCreate("H1 UPPER BB",OBJ_TEXT,0,ObjectGet("BB3H",OBJPROP_TIME1)+adjust,ObjectGet("BB3H",OBJPROP_PRICE2));
  ObjectCreate("H1 LOWER BB",OBJ_TEXT,0,ObjectGet("BB3L",OBJPROP_TIME1)+adjust,ObjectGet("BB3L",OBJPROP_PRICE2));
  
  ObjectSetText("M5 UPPER BB","  M5 UPPER BB",FontSize,FontType,TF1Color);   
  ObjectSetText("M5 LOWER BB","  M5 LOWER BB",FontSize,FontType,TF1Color);      
  ObjectSetText("M15 UPPER BB"," M15 UPPER BB",FontSize,FontType,TF2Color); 
  ObjectSetText("M15 LOWER BB"," M15 LOWER BB",FontSize,FontType,TF2Color);   
 
  ObjectSetText("H1 UPPER BB","  H1 UPPER BB",FontSize,FontType,TF3Color);
  ObjectSetText("H1 LOWER BB","  H1 LOWER BB",FontSize,FontType,TF3Color);
  // Alerts
  
   if(TF1_Alert)
      {
       if(Ask>BB1H) Alert(Symbol()+" Price is Above TF1 Bollinger Band: Overbought");
       if(Bid<BB1L) Alert(Symbol()+" Price is Below TF1 Bollinger Band: Oversold");
      }
    
   if(TF2_Alert)
      {
       if(Ask>BB2H) Alert(Symbol()+" Price is Above TF2 Bollinger Band: Overbought");
       if(Bid<BB2L) Alert(Symbol()+" Price is Below TF2 Bollinger Band: Oversold");
      } 
      
   if(TF3_Alert)
      {
       if(Ask>BB3H) Alert(Symbol()+" Price is Above TF3 Bollinger Band: Overbought");
       if(Bid<BB3L) Alert(Symbol()+" Price is Below TF3 Bollinger Band: Oversold");
      }
      
        
   if(MultiTF_Alert)
      {
       if(Ask>BB1H && Ask>BB2H && Ask>BB3H) 
         {
         Alert(Symbol()+": Price is above all Bollinger Bands: Extremely OverBought");
         Sleep(10000);
         }
      if(Bid<BB1L && Bid<BB2L && Bid<BB3L) 
        {
        Alert(Symbol()+": Price is below all Bollinger Bands: Extremely Oversold");
        Sleep(10000);
        }
     } // end if(MultiTF_Alert)
   
  } // end for(int i=0;i<limit;i++)
 }//end if New Bar 

   return(0);
  }
//*************************************************************
//custom function saves processing
bool New_Bar()
{
  static datetime New_Time=0;
  
     if(New_Time==Time[0])
      {
      return(false);
      }
      
     else if (New_Time!=Time[0]) return(true); //Bar has changed
     
}